;;; $Id: contlib.tst,v 1.10 1993/12/23 09:37:43 queinnec Exp $

;;; This file contains tests on 
;;;	prompt/control,
;;;	reset/shift,
;;;     spawn,
;;;     splitter/abort/call/pc,
;;;     dynamic-wind.
;;; It also contains the examples of the companion paper.

;;; Removed shift2/reset2 tests which were false.

(define (multiply-list list-of-numbers)
  (call/cc (lambda (exit)
             (define (mult l)
               (if (null? l) 1
                   (if (equal? (car l) 0) 
                       ;; Use equal? rather than = which requires numbers
                       ;; necessary for the third example below.
                       (exit 0) 
                       (* (car l) (mult (cdr l))) ) ) )
             (mult list-of-numbers) )) )
   ---
(multiply-list '(1 2 3 4))
   24
(multiply-list '(1 2 3 4 0 foo))
   0
(multiply-list '(1 2 bar 3 4 0 foo))
   0


;;;============================================ prompt/control
(prompt (* 2 (control (lambda (f) 3))))           
   3
(prompt (* 2 (control (lambda (f) (* 5 (f 3)))))) 
   30
(prompt (* 2 (control (lambda (f) (f (f 3))))))
   12
((prompt (* 2 (control (lambda (f) f)))) 3)
   6
(prompt (* 5 
           (prompt (* 2 
                      (control (lambda (f2) 
                                 ; {\tt f2}$=\lambda x.2*x$    
                                 (* 3 (control (lambda (f3) 
                                                 ;{\tt f3}$=\lambda x.3*x$
                                                 7 ))) )) )) ))
  35 
;;; testing f2 and f3
(prompt (* 5 
           (prompt (* 2 
                      (control (lambda (f2) 
                                 ; {\tt f2}$=\lambda x.2*x$    
                                 (* 3 (control (lambda (f3) 
                                                 ;{\tt f3}$=\lambda x.3*x$
                                                 (f2 7) ))) )) )) ))
  70
(prompt (* 5 
           (prompt (* 2 
                      (control (lambda (f2) 
                                 ; {\tt f2}$=\lambda x.2*x$    
                                 (* 3 (control (lambda (f3) 
                                                 ;{\tt f3}$=\lambda x.3*x$
                                                 (f3 7) ))) )) )) ))
  105

(prompt (* 5 (
              (prompt (* 2 
                         (control (lambda (f2)             
                                    ; {\tt f2}$=\lambda x.2*x$
                                    (lambda ()
                                      (* 3 (control (lambda (f3) 
                                                      ; {\tt f3}$=\lambda x.5*(3*x)$
                                                      7 ))) ) )) )) )))
   7
;;; testing f2 and f3
(prompt (* 5 (
              (prompt (* 2 
                         (control (lambda (f2)             
                                    ; {\tt f2}$=\lambda x.2*x$
                                    (lambda ()
                                      (* 3 (control (lambda (f3) 
                                                      ; {\tt f3}$=\lambda x.5*(3*x)$
                                                      (f2 7) ))) ) )) )) )))
   14
(prompt (* 5 (
              (prompt (* 2 
                         (control (lambda (f2)             
                                    ; {\tt f2}$=\lambda x.2*x$
                                    (lambda ()
                                      (* 3 (control (lambda (f3) 
                                                      ; {\tt f3}$=\lambda x.5*(3*x)$
                                                      (f3 7) ))) ) )) )) )))
   105

(prompt (* 5
           ((lambda (x) (control (lambda (f1) x)))  ; = $\phi$
            (* 3 (control (lambda (f2)
                            ; {\tt f2}$=\lambda u.5*\phi(3*u)$
                            (* 2 (f2 7)) ))) ) )) 
   21
;;; testing f2 and f1
(prompt (* 5
           ((lambda (x) (control (lambda (f1) x)))  ; = $\phi$
            (* 3 (control (lambda (f2)
                            ; {\tt f2}$=\lambda u.5*\phi(3*u)$
                            (* 2 (f2 (f2 7))) ))) ) )) 
   21
(prompt (* 5                      ; f1= \lambda v. 2*5*v
           ((lambda (x) (control (lambda (f1) (f1 x))))  ; = $\phi$
            (* 3 (control (lambda (f2)
                            ; {\tt f2}$=\lambda u.5*\phi(3*u)$
                            (* 2 (f2 7)) ))) ) )) 
   210
(prompt (* 5                      ; f1= \lambda v. 2*5*v
           ((lambda (x) (control (lambda (f1) (f1 (f1 x)))))  ; = $\phi$
            (* 3 (control (lambda (f2)
                            ; {\tt f2}$=\lambda u.5*\phi(3*u)$
                            (* 2 (f2 7)) ))) ) )) 
   2100


;;; these tests come from ~scm/decc/decc6-tests.scm
(prompt (+ 1 (control (lambda (k) 0))))
   0
(prompt (+ 1 (control (lambda (k) (k 0)))))
   1
(prompt (+ 1 (control (lambda (k) (k (k 0))))))
   2
(prompt (+ 1 (prompt (+ 1 (control (lambda (k) 0))))))
   1
(let ((g (prompt (* 2 (control (lambda (k) k))))))
  (* 3 (prompt (* 5 (control (lambda (ignore) (g 7)))))) )
   42
;;; the example where Felleisen and Danvy diverge
(prompt ((lambda (f g)
           (f (g 2)) )
         (lambda (n) (control (lambda (c) n))) ; c = 1+
         (lambda (p) (control (lambda (d) (+ 1 (d p))))) ; d = f
         ))
   2
;;; testing back call/cc with control and prompt
(let ()
  (define (call/cc f)
    (control (lambda (pc) 
               (pc (f (lambda (v)
                        (control (lambda (ignore-pc) (pc v))) ))) )) )
  (prompt (call/cc (lambda (k) 'a))
          ))
   a
(let ()
  (define (call/cc f)
    (control (lambda (pc) 
               (pc (f (lambda (v)
                        (control (lambda (ignore-pc) (pc v))) ))) )) )
  (prompt (call/cc (lambda (k) (k 'a)))
          ))
   a
(let ()
  (define (call/cc f)
    (control (lambda (pc) 
               (pc (f (lambda (v)
                        (control (lambda (ignore-pc) (pc v))) ))) )) )
  (prompt (call/cc (lambda (k) (cons (k 'a) 1)))
          ))
   a
(let ()
  (define (call/cc f)
    (control (lambda (pc) 
               (pc (f (lambda (v)
                        (control (lambda (ignore-pc) (pc v))) ))) )) )
  (prompt (call/cc call/cc)
          ))
   ---
(let ()
  (define (call/cc f)
    (control (lambda (pc) 
               (pc (f (lambda (v)
                        (control (lambda (ignore-pc) (pc v))) ))) )) )
  (prompt ((lambda (a)
             (begin (set! a (call/cc (lambda (k) k)))
                    (a (lambda (x) 1)) ) )
           2 )
          ))
   1
(let ()
  (define (call/cc f)
    (control (lambda (pc) 
               (pc (f (lambda (v)
                        (control (lambda (ignore-pc) (pc v))) ))) )) )
  (prompt ((lambda (a b)
             (begin (set! a (call/cc (lambda (k) k)))
                    (begin (set! b (+ 1 b))
                           (a (lambda (x) b)) ) ) )
           3 0 )
          ))
   2
;;; test that lexical contexts are preserved through continuations.
(let ()
  (define (call/cc f)
    (control (lambda (pc) 
               (pc (f (lambda (v)
                        (control (lambda (ignore-pc) (pc v))) ))) )) )
  (prompt ((lambda (foo)
             (begin
               (set! foo ((lambda (z)
                            (lambda (x)
                              ((lambda (y) (begin (set! z x) y))
                               z ) ) )
                          'z ))
               (cons (foo (call/cc (lambda (k) ; store A and return Z
                                     (k 'a) )))
                     (cons (foo (call/cc (lambda (k) ; store B, return A
                                           (cons 1 (k 'b)) )))
                           (cons (foo (call/cc (lambda (k) 
                                                 ; store continuation, return B
                                                 (cons 2 (k k)) )))
                                 (cons ((lambda (x)
                                          (if (symbol? x) 'ee (x 'e)) )
                                        (foo 'd) )
                                       (cons (foo 'f)
                                             '() ) ) ) ) ) ))
           'foo )
          ))
   (*or* (z a d ee d)   ; left->right
         (B ?- D EE Z)  ; right->left
         )
(let ()
  (define (call/cc f)
    (control (lambda (pc) 
               (pc (f (lambda (v)
                        (control (lambda (ignore-pc) (pc v))) ))) )) )
  (prompt ((lambda (foo)
             (begin
               (set! foo ((lambda (z)
                            (lambda (x u)
                              ((lambda (y) (begin (set! z x) y))
                               z ) ) )
                          'z ))
               (cons (foo (call/cc (lambda (k)
                                     (k 'a) ))
                          1 )
                     (cons (foo (call/cc (lambda (k)
                                           (cons 1 (k 'b)) ))
                                2 )
                           (cons (foo (call/cc (lambda (k)
                                                 (cons 2 (k k)) ))
                                      3 )
                                 (cons ((lambda (x)
                                          (if (symbol? x) 'ee (x 'e)) )
                                        (foo 'd 4) )
                                       (cons (foo 'f 5) '()) ) ) ) ) ) )
           'foo )
          ))
   (*or* (z a d ee d)   ; left->right
         (B ?- D EE Z)  ; right->left
         )



;;;============================================ shift/reset
(reset (* 2 (shift f 3)))
   3
(reset (* 2 (shift f (* 5 (f 3)))))
   30
(reset (* 2 (shift f (f (f 3)))))
   12
((reset (* 2 (shift f f))) 3)
   6
(reset (* 5 
          (reset (* 2 (shift f2             ;\relax {\tt f2}$=\lambda x.2*x$
                             (* 3 (shift f3 ;\relax {\tt f3}$=\lambda x.3*x$
                                         7 ))) ))))
   35
;;; testing f2 and f3
(reset (* 5 
          (reset (* 2 (shift f2             ;\relax {\tt f2}$=\lambda x.2*x$
                             (* 3 (shift f3 ;\relax {\tt f3}$=\lambda x.3*x$
                                         (f2 7) ))) ))))
   70
(reset (* 5 
          (reset (* 2 (shift f2             ;\relax {\tt f2}$=\lambda x.2*x$
                             (* 3 (shift f3 ;\relax {\tt f3}$=\lambda x.3*x$
                                         (f3 7) ))) ))))
   105

(reset  (* 5 (
              (reset (* 2
                        (shift f2            ; {\tt f2}$=\lambda x.2*x$
                               (lambda () 
                                 (* 3 (shift f3 
                                             ; {\tt f3}$=\lambda x.(3*x)$
                                             7 )) )) )) )))
   7
;;; testing f2 and f3
(reset  (* 5 (
              (reset (* 2
                        (shift f2             ; {\tt f2}$=\lambda x.2*x$
                               (lambda () 
                                 (* 3 (shift f3 
                                             ; {\tt f3}$=\lambda x.(3*x)$
                                             (f2 7) )) )) )) )))
   14
(reset  (* 5 (
              (reset (* 2
                        (shift f2             ; {\tt f2}$=\lambda x.2*x$
                               (lambda () 
                                 (* 3 (shift f3 
                                             ; {\tt f3}$=\lambda x.5*3*x$
                                             (f3 7) )) )) )) )))
   105

(reset (* 5 
         ((lambda (x) (shift f1 x))
          (* 3 (shift f2 (* 2 (f2 7))))  )  )) 
   42
;;; testing f2 and f1
(reset (* 5 
         ((lambda (x) (shift f1 x))
          (* 3 (shift f2 (* 2 (f2 (f2 7)))))  )  )) 
   126
(reset (* 5 
         ((lambda (x) (shift f1 (f1 x)))
          (* 3 (shift f2 (* 2 (f2 7))))  )  )) 
210
(reset (* 5    ;f1= lambda v . 5*v
         ((lambda (x) (shift f1 (f1 (f1 x))))
          (* 3 (shift f2 (* 2 (f2 7))))  )  )) 
1050


;;; tests coming from ~/scm/DECC/decc6-tests.scm
(reset (+ 1 (shift k 0)))
   0
(reset (+ 1 (shift k (k 0))))
   1
(reset (+ 1 (shift k (k (k 0)))))
   2
(reset (+ 1 (reset (1 (shift k 0)))))
   1
((lambda (g)
  (* 3 (reset (* 5 (shift dummy (g 7))))) )
  (reset (* 2 (shift k k))) )
   42
;;; These come from Danvy himself
(let () 
  (define (rev l)
    (reset (rever l)) )
  (define (rever l)
    (if (null? l)
        '()
        (shift c (cons (car l)
                       (c (rever (cdr l))) )) ) )
  (rev '(1 2 3)) )
   (3 2 1)
(((lambda (f)   ;; Y
    (reset ((lambda (x)
              (f (lambda (a) ((x x) a))) )
            (shift c (c c)) )) )
  (lambda (f)
    (lambda (n)
      (if (< n 2)
          1
          (* n (f (- n 1))) ) ) ))
 5 )
   120
;;; The difference with Felleisen
(reset
 ((lambda (f g) (f (g 2)))
  (lambda (n) (shift k n))
  (lambda (x) (shift c (+ 1 (c x)))) ) )
   3  
;;; testing back call/cc with shift/reset
(let () 
  (define (call/cc f)
    (shift pc (pc (f (lambda (v) 
                       (shift ignore-pc (pc v)) )))) )
  (reset (call/cc (lambda (k) 'a))
         ))
   a
(let () 
  (define (call/cc f)
    (shift pc (pc (f (lambda (v) 
                       (shift ignore-pc (pc v)) )))) )
  (reset (call/cc (lambda (k) (k 'a)))
         ))
   a
(let () 
  (define (call/cc f)
    (shift pc (pc (f (lambda (v) 
                       (shift ignore-pc (pc v)) )))) )
  (reset (call/cc (lambda (k) (cons (k 'a) 1)))
         ))
   a
(let () 
  (define (call/cc f)
    (shift pc (pc (f (lambda (v) 
                       (shift ignore-pc (pc v)) )))) )
  (reset (call/cc call/cc)
         ))
   ---
(let () 
  (define (call/cc f)
    (shift pc (pc (f (lambda (v) 
                       (shift ignore-pc (pc v)) )))) )
  (reset ((lambda (a)
            (begin (set! a (call/cc (lambda (k) k)))
                   (a (lambda (x) 1)) ) )
          2 )
         ))
   1
(let () 
  (define (call/cc f)
    (shift pc (pc (f (lambda (v) 
                       (shift ignore-pc (pc v)) )))) )
  (reset ((lambda (a b)
            (begin (set! a (call/cc (lambda (k) k)))
                   (begin (set! b (+ 1 b))
                          (a (lambda (x) b)) ) ) )
          3 0 )
         ))
   2
;;; test that lexical contexts are preserved through continuations.
(let () 
  (define (call/cc f)
    (shift pc (pc (f (lambda (v) 
                       (shift ignore-pc (pc v)) )))) )
  (reset ((lambda (foo)
            (begin
              (set! foo ((lambda (z)
                           (lambda (x)
                             ((lambda (y) (begin (set! z x) y))
                              z ) ) )
                         'z ))
              (cons (foo (call/cc (lambda (k) ; store A and return Z
                                    (k 'a) )))
                    (cons (foo (call/cc (lambda (k) ; store B, return A
                                          (cons 1 (k 'b)) )))
                          (cons (foo (call/cc (lambda (k)
                                                ; store continuation, return B
                                                (cons 2 (k k)) )))
                                (cons ((lambda (x)
                                         (if (symbol? x) 'ee (x 'e)) )
                                       (foo 'd) )
                                      (cons (foo 'f)
                                            '() ) ) ) ) ) ))
          'foo )
         ))
   (*or* (z a d ee d)   ; left->right
         (B ?- D EE Z)  ; right->left
         )
(let () 
  (define (call/cc f)
    (shift pc (pc (f (lambda (v) 
                       (shift ignore-pc (pc v)) )))) )
  (reset ((lambda (foo)
            (begin
              (set! foo ((lambda (z)
                           (lambda (x u)
                             ((lambda (y) (begin (set! z x) y))
                              z ) ) )
                         'z ))
              (cons (foo (call/cc (lambda (k)
                                    (k 'a) ))
                         1 )
                    (cons (foo (call/cc (lambda (k)
                                          (cons 1 (k 'b)) ))
                               2 )
                          (cons (foo (call/cc (lambda (k)
                                                (cons 2 (k k)) ))
                                     3 )
                                (cons ((lambda (x)
                                         (if (symbol? x) 'ee (x 'e)) )
                                       (foo 'd 4) )
                                      (cons (foo 'f 5) '()) ) ) ) ) ) )
          'foo )
         ))
   (*or* (z a d ee d)   ; left->right
         (B ?- D EE Z)  ; right->left
         )




;;;============================================ spawn
(spawn (lambda (c) (c (lambda (f) 3))))
   3
(spawn (lambda (c) (* 2 (c (lambda (f) (* 5 (f 3)))))))
   30
(spawn(lambda (c) (* 2 (c (lambda (f) (f (f 3)))))))
   12
((spawn (lambda (c) (* 2 (c (lambda (f) f))))) 3) 
   6
(let ((c (spawn (lambda (c) c)))) (* 2 (c (lambda (f) (f 3)))))
   *** ; C out of extent
(spawn (lambda (c1) 
         (* 5 (spawn (lambda (c2) 
                       (* 2 (c2 (lambda (f2)    
                                  (* 3 (c2 (lambda (f3) 
                                             7 ))) ))) ))) ))
   35
(spawn (lambda (c1)                           
         (* 5 ((spawn (lambda (c2)
                        (* 2 (c2 (lambda (f2)
                                   (lambda ()
                                     (* 3 (c2 (lambda (f3) 
                                                7 ))) ) ))) )))) )) 
  *** 
(spawn (lambda (c1)                           
         (* 5 ((spawn (lambda (c2)
                        (* 2 (c2 (lambda (f2)
                                   (lambda ()
                                     (* 3 (c1 (lambda (f3) 
                                                7 ))) ) ))) )))) )) 
  7
(spawn (lambda (c1)                          
         (* 5 ((spawn (lambda (c2)
                        (* 2 (c1 (lambda (f2)
                                   (lambda ()
                                     (* 3 (c2 (lambda (f3) 
                                                7 ))) ) ))) )))) )) 
   ---
(spawn (lambda (c1)                          
         (* 5 ((spawn (lambda (c2)
                        (* 2 (c1 (lambda (f2)
                                   (lambda ()
                                     (* 3 (c1 (lambda (f3) 
                                                7 ))) ) ))) )))) )) 
   ---
(spawn (lambda (c)
         (* 5 ((lambda (x) (c (lambda (f1) x)))
               ; f2=lambda u. 5*phi(3u)
               (* 3 (c (lambda (f2) (* 2 (f2 7)))))  ))  )) 
;; this is an example where reification occurs upto the nearest context
;; and there are two possible such contexts.
   42

(spawn (lambda (c1)    
          (* 5 (spawn (lambda (c2)
                        (* 2 ((c1 (lambda (f1) ; f1=$\lambda u.(5*2*(u))(\phi)$
                                    (f1 (lambda () 
                                          (f1 (lambda ()
                                                (* 7 (c2 (lambda (f2)
                                                           (* 11 (f2 13)) ))) 
                                                )) )) )))) ))) ))
   100100 ; 5*2*5*11*2*7*13
(spawn (lambda (c1)
         (spawn (lambda (c2)
                  (c1 (lambda (f) (* 3 (f 7))))
                  (c2 (lambda (g) 5)) )) ))  
   15  
(spawn (lambda (c1)
         (spawn (lambda (c2)
                  (c1 (lambda (f) (f (* 2 (f 3)))))
                  (* 5 (c2 (lambda (g) (g 7)))) )) ))
   35
(spawn (lambda (c1)
         (spawn (lambda (c2)
                  (c1 (lambda (f) (f (* 2 (f 3)))))
                  (* 5 (c2 (lambda (g) 7))) )) ))
   7
(spawn 
 (lambda (c1)
   (spawn
    (lambda (c2)
      (* 2 (let ((fun (c1 (lambda (f1)
                            (* 3 (f1 (lambda (n)
                                       (* 5 (f1 (lambda (n)
                                                  (c2 (lambda (f2)
                                                        1 ))))))))))))
             (* 7 (fun 11)) )) )) ))
   210
((spawn (lambda (c1)
          (* 5 (spawn (lambda (c2)
                        (* 2 ((c1 (lambda (f1) 
                                    (lambda (g) (g f1 c2)) )))) ))) ))
 (lambda (f1 c2) (f1 (lambda () (* 7 (c2 (lambda (f2) (* 11 (f2 13)))))))) )
   10010 
;;; These tests come from ~/scm/DECC/decc6-tests.scm
;;; Some are commented out since they assume a strict spawn.
((spawn (lambda (j) j))
 (lambda (c) c) )
   ***
;(spawn (lambda (j)
;         (j (lambda (c)          ; c = identity !
;              (j (lambda (cc) cc)) )) ))
;   ***  ; cannot use J twice (see paper)
((spawn (lambda (j)
          (j (j (lambda (c)             ; c = j !
                  (c (lambda (cc)       ; cc = identity
                       cc )) ))) ))
 3 )
   3
(define (product0 l exit)
  (if (null? l) 1
      (if (= (car l) 0) 
          (exit 0)
          (* (car l) (product0 (cdr l) exit)) ) ) )
   ---
(define (spawn/exit proc)
  (spawn (lambda (j)
           (proc (lambda (exit-value)
                   (j (lambda (c) exit-value)) )) )) )
   ---
(define (plus2list l1 l2)
  (+ (spawn/exit (lambda (exit) (product0 l1 exit)))
     (spawn/exit (lambda (exit) (product0 l2 exit))) ) )
   ---
(plus2list '(1 2 3) '(4 5 6))
   126
(plus2list '(1 0 2) '(4 5 6))
   120
(plus2list '(1 2 3) '(4 5 0))
   6
(define (times2list l1 l2)
  (spawn/exit (lambda (exit)
                (* (product0 l1 exit)
                   (product0 l2 exit) ) )) )
   ---
(times2list '(1 2 3) '(4 5 6))
   720
(times2list '(1 0 2) '(4 5 6))
   0
(times2list '(1 2 3) '(4 5 0))
   0
(define (//search tree fn)
  (spawn (lambda (j)
           (define (search tree)
             (if (pair? tree)
                 (begin (search (car tree))
                        (search (cdr tree)) )
                 (if (fn tree)
                     (j (lambda (c)
                          (cons tree (lambda () (c #f))) ))
                     'void ) ) )
           (search tree) )) )
   ---
(define (find-all tree fn)
  (define (next result)
    (if result
        (cons (car result) (next ((cdr result))))
        '() ) )
  (next (//search tree fn)) )
   ---
(find-all '(a (b . c) . d) (lambda (leaf) #t))
   (a b c d)
(spawn (lambda (j)
         (let ((f (j (lambda (c) (cons 2 (c j))))))
           (cons 7 (f (lambda (x) (cons 3 (x 5))))) ) ))
   (2 3 7 . 5)
(spawn (lambda (j)
          (cons 2 (j (j (lambda (c1) ; c1 = (cons 2 (j ?))
                          (cons 3 (c1 (lambda (c2)
                                        ; c2 = (cons 3 (cons 2 ?))
                                        4 ))) )))) ))
   (3 . 4)
(spawn (lambda (j)
          (cons 2 (j (j (lambda (c1) ; c1 = (cons 2 (j ?))
                          (cons 3 (c1 (lambda (c2)
                                        ; c2 = (cons 3 (cons 2 ?))
                                        (c2 4) ))) )))) ))
   (3 2 . 4)
(spawn (lambda (j)
         (cons 2 (j (j (lambda (c1) ; c1 = (cons 2 (j ?))
                          (cons 3 (c1 (lambda (c2)
                                        ; c2 = (cons 3 (cons 2 ?))
                                       (c1 (lambda (c) 
                                              ; c = (cons 3 ?)
                                              4 )) ))) )))) ))
   (3 . 4)
(spawn (lambda (j)
          (cons (j (lambda (c) ; c = (cons ? (j (lambda (c) 5)))
                     (cons 2 (c (cons 3 (c 4)))) ))
                (j (lambda (c) 5)) ) ))
   (*or* (2 . 5)    ; left->right
         5          ; right->left
         )
(spawn (lambda (j)
          (cons (j (lambda (c) ; c = (cons ? (j (lambda (c) (c 5))))
                     (cons 2 (c (cons 3 (c 4)))) ))
                (j (lambda (c) 
                     ; c = (cons 2 (c (cons 3 ?)))
                     (c 5) )) ) ))
   (2 (3 4 . 5) . 5)
(spawn (lambda (j)
          (cons (j (lambda (c) ; c = (cons ? (j (lambda (c) (c (c 5)))))
                     (cons 2 (c (cons 3 (c 4)))) ))
                (j (lambda (c) (c (c 5)))) ) ))
   (*or* (2 (3 4 4 . 5) (3 4 4 . 5) . 5)              ; left->right
         (2 (3 4 2 (3 4 . 5) . 5) 2 (3 4 . 5) . 5)    ; right->left
         )
(spawn (lambda (j)
          (let ((cc 'wait))
            (cons (j (lambda (c) ; c = (cons ? (j (lambda (c) (cc 5))))
                       (cons 2 (c 3)) ))
                  (j (lambda (c) 
                       ; c = (cons (j (lambda (c) (cons 2 (c 3)))) ?)
                       (set! cc c)
                       (cc 5) )) ) ) ))
   (2 3 . 5)
(spawn (lambda (j)
         (cons (j (lambda (c1)
                    ; c1 = (cons 2 (c2 (cons 3 ?)))
                    (cons 6 (c1 5)) ))
               (j (lambda (c2)
                    ; c2 = (cons (j (lambda (c1) (cons 6 (c1 5)))) ?)
                    (cons 2 (c2 (cons 3 (c2 4)))) )) ) ))
   (*or* (6 2 5 3 5 . 4)      ; left->right
         (2 6 5 3 6 5 . 4)    ; right->left
         )
;;; testing back call/cc with spawn
(spawn (lambda (bottom)
         (define (call/cc f)
           (bottom (lambda (pc)
                     (pc (f (lambda (v)
                              (bottom (lambda (ignore) (pc v))) ))) )) )
         (call/cc (lambda (k) 'a))
         ))
   a
(spawn (lambda (bottom)
         (define (call/cc f)
           (bottom (lambda (pc)
                     (pc (f (lambda (v)
                              (bottom (lambda (ignore) (pc v))) ))) )) )
         (call/cc (lambda (k) (k 'a)))
         ))
   a
(spawn (lambda (bottom)
         (define (call/cc f)
           (bottom (lambda (pc)
                     (pc (f (lambda (v)
                              (bottom (lambda (ignore) (pc v))) ))) )) )
         (call/cc (lambda (k) (cons (k 'a) 1)))
         ))
   a
(spawn (lambda (bottom)
         (define (call/cc f)
           (bottom (lambda (pc)
                     (pc (f (lambda (v)
                              (bottom (lambda (ignore) (pc v))) ))) )) )
         (call/cc call/cc)
         ))
   ---
(spawn (lambda (bottom)
         (define (call/cc f)
           (bottom (lambda (pc)
                     (pc (f (lambda (v)
                              (bottom (lambda (ignore) (pc v))) ))) )) )
         ((lambda (a)
            (begin (set! a (call/cc (lambda (k) k)))
                   (a (lambda (x) 1)) ) )
          2 )
         ))
   1
(spawn (lambda (bottom)
         (define (call/cc f)
           (bottom (lambda (pc)
                     (pc (f (lambda (v)
                              (bottom (lambda (ignore) (pc v))) ))) )) )
         ((lambda (a b)
            (begin (set! a (call/cc (lambda (k) k)))
                   (begin (set! b (+ 1 b))
                          (a (lambda (x) b)) ) ) )
          3 0 )
         ))
   2
;;; test that lexical contexts are preserved through continuations.
(spawn (lambda (bottom)
         (define (call/cc f)
           (bottom (lambda (pc)
                     (pc (f (lambda (v)
                              (bottom (lambda (ignore) (pc v))) ))) )) )
         ((lambda (foo)
            (begin
              (set! foo ((lambda (z)
                           (lambda (x)
                             ((lambda (y) (begin (set! z x) y))
                              z ) ) )
                         'z ))
              (cons (foo (call/cc (lambda (k) ; store A and return Z
                                    (k 'a) )))
                    (cons (foo (call/cc (lambda (k) ; store B, return A
                                          (cons 1 (k 'b)) )))
                          (cons (foo (call/cc (lambda (k)
                                                ; store continuation, return B
                                                (cons 2 (k k)) )))
                                (cons ((lambda (x)
                                         (if (symbol? x) 'ee (x 'e)) )
                                       (foo 'd) )
                                      (cons (foo 'f)
                                            '() ) ) ) ) ) ))
          'foo )
         ))
   (*or* (z a d ee d)   ; left->right
         (B ?- D EE Z)  ; right->left
         )
(spawn (lambda (bottom)
         (define (call/cc f)
           (bottom (lambda (pc)
                     (pc (f (lambda (v)
                              (bottom (lambda (ignore) (pc v))) ))) )) )
         ((lambda (foo)
            (begin
              (set! foo ((lambda (z)
                           (lambda (x u)
                             ((lambda (y) (begin (set! z x) y))
                              z ) ) )
                         'z ))
              (cons (foo (call/cc (lambda (k)
                                    (k 'a) ))
                         1 )
                    (cons (foo (call/cc (lambda (k)
                                          (cons 1 (k 'b)) ))
                               2 )
                          (cons (foo (call/cc (lambda (k)
                                                (cons 2 (k k)) ))
                                     3 )
                                (cons ((lambda (x)
                                         (if (symbol? x) 'ee (x 'e)) )
                                       (foo 'd 4) )
                                      (cons (foo 'f 5) '()) ) ) ) ) ) )
          'foo )
         ))
   (*or* (z a d ee d)   ; left->right
         (B ?- D EE Z)  ; right->left
         )



;;;============================================ splitter/abort/call/pc
(splitter (lambda (m) 3))
   3
(splitter (lambda (m) (* 2 (abort m (lambda () 4))))) 
    4
(splitter (lambda (m) (* 2 (call/pc m (lambda (f) 3))))) 
   6
(splitter (lambda (m) (* 2 (call/pc m (lambda (f) (f (f 3)))))))
   24
((splitter (lambda (m) (* 2 (call/pc m (lambda (f) 
                                         (abort m (lambda () f)) )))))
 3 ) 
   6
(call/pc (splitter (lambda (m) m)) (lambda (f) ldots))
   *** ;;;  Error: out of extent
(splitter 
 (lambda (m1)
   (* 5 (splitter 
         (lambda (m2)
           (* 2 (call/pc m2 (lambda (f2)
                              (* 3 (call/pc m1 (lambda (f3)
                                                 7 ))) ))) ))) ))
   210
((splitter (lambda (m1)
             (* 5 (splitter 
                   (lambda (m2)
                     (* 2 ((call/pc m1 (lambda (f1) ; f1=$\lambda u.(5*2*(u))(\phi)$
                                         (abort m1 (lambda ()
                                                     (lambda (g) (g f1 m2)) 
                                                     )) )))) ))) ))
 ;; let $\phi$ be the value of the following term. It will be bound to {\tt g}.
 (lambda (f1 m2) (f1 (lambda () 
                       (* 7 (call/pc m2 (lambda (f2) (* 11 (f2 13))))) ))) )
   *** ; m2 out of extent.
(splitter 
 (lambda (m)
   (* 5 ((lambda (x) (call/pc m (lambda (f1) (abort m (lambda() x)))))
         (* 3 (call/pc m (lambda (f2) 
                           (abort m (lambda () (* 2 (f2 7)))) ))) )) ))
    21  
(splitter (lambda (m1)
            (splitter (lambda (m2)
                        (call/pc m1 (lambda (f)
                                      ; f=\u.(begin u (call/pc m2 ...))
                                      (abort m1 (lambda () (* 3 (f 7)))) ))
                        (call/pc m2 (lambda (g)
                                      (abort m2 (lambda () 5)) )) )) )) 
    *** ; (call/pc m2 ) out of extent.
(splitter (lambda (m1)
            (splitter (lambda (m2)
                        (call/pc m1 (lambda (f)
                                      (* 2 (f 3)) ))
                        (* 5 (call/pc m2 (lambda (g) 7))) )) ))
   35
(splitter (lambda (m1)
            (splitter (lambda (m2)
                        (call/pc m1 (lambda (f)
                                      (* 2 (f 3)) ))
                                           (abort m2 (lambda () 7)) ))) )
    7
((splitter (lambda (m1)
             (* 5 (splitter (lambda (m2)
                              (* 2 ((call/pc 
                                     m1 (lambda (f1) ; f1=\x.5*2*x
                                          (abort m1 (lambda ()
                                                      (lambda (g) (g f1 m2))
                                                      )) ) ))) ))) ))
 (lambda (f1 m2) (f1 (lambda () 
                       (* 7 (call/pc m2 (lambda (f2) (* 11 (f2 13))))) ))) )
    ;140140 ; if taking the last frame
    ***     ; if not
(let ()
  (define (spawn f)
    (splitter (lambda (mark)
                (f (lambda (g)
                     (call/pc mark (lambda (pc)
                                     (abort mark (lambda () (g pc)))
                                    )) )) )) )
  (spawn 
   (lambda (c1)
     (spawn
      (lambda (c2)
        (* 2 (let ((fun (c1 (lambda (f1)
                              (* 3 (f1 (lambda (n)
                                         (* 5 (f1 (lambda (n)
                                                    (c2 (lambda (f2)
                                                          1 ))))))))))))
               (* 7 (fun 11)) )) )) ))
  )
   ;3  ; if taking the last frame
   *** ; if not
;;; these additional tests come from ~/themes/TVS/vts.tst
(let ()
  (define (cps-fact n k)
    (if (= n 1) (k 1)
        (cps-fact (- n 1) (lambda (r) (k (* n r)))) ) )
  (cps-fact 4 (lambda (x) x)) )
   24
(let ()
  (define (cps-fact n k)
    (if (= n 1) (k 1)
        (cps-fact (- n 1) (lambda (r) (k (* n r)))) ) )
  (cps-fact 4 (lambda (x) (* 2 x))) )
   48
(let ()
  (define (cps-fact n k)
    (if (= n 1) (k 1)
        (cps-fact (- n 1) (lambda (r) (k (* n r)))) ) )
  (splitter (lambda (g) 
              (cps-fact 4 (lambda (r) (abort g (lambda () r)))) )) )
   24
(let ()
  (define (finalizing-fact n terminator)
    (if (= n 1) (terminator 1)
        (* n (finalizing-fact (- n 1) terminator)) ) )
  (define (factn n)
    (splitter 
     (lambda (g) 
       (finalizing-fact n (lambda (one) 
                            (call/pc g (lambda (f) 
                                         (abort g (lambda () f)) )) )) ) ) )
  (list ((factn 4) 1) ((factn 4) 2)) )
   (24 48)
;;; testing back call/cc with splitter
;;; NOTE il semble que dans splitter.tests le codage de call/cc par 
;;; splitter soit faux. C'est:
;;; (define call/cc 
;;;          (lambda (f)
;;;            (call/pc m0 (lambda (k) 
;;;                          (k (f (lambda (v)
;;;                                  (abort m0
;;;                                         (lambda () (k v)) ) ))) )) ) )
;;; le `k' autour de (f..) est superflu ! Il faudrait ecrire un exemple
;;; ou cela se voit.

(splitter 
 (lambda (bottom)
   (define (call/cc f)
     (call/pc bottom (lambda (pc)
                       (f (lambda (v)
                            (abort bottom (lambda () (pc v))) )) )) )
   (call/cc (lambda (k) 'a))
   ))
   a
(splitter 
 (lambda (bottom)
   (define (call/cc f)
     (call/pc bottom (lambda (pc)
                       (f (lambda (v)
                            (abort bottom (lambda () (pc v))) )) )) )
   (call/cc (lambda (k) (k 'a)))
   ))
   a
(splitter 
 (lambda (bottom)
   (define (call/cc f)
     (call/pc bottom (lambda (pc)
                       (f (lambda (v)
                            (abort bottom (lambda () (pc v))) )) )) )
   (call/cc (lambda (k) (cons (k 'a) 1)))
   ))
   a
(splitter 
 (lambda (bottom)
   (define (call/cc f)
     (call/pc bottom (lambda (pc)
                       (f (lambda (v)
                            (abort bottom (lambda () (pc v))) )) )) )
   (call/cc call/cc)
   ))
   ---
(splitter 
 (lambda (bottom)
   (define (call/cc f)
     (call/pc bottom (lambda (pc)
                       (f (lambda (v)
                            (abort bottom (lambda () (pc v))) )) )) )
   ((lambda (a)
      (begin (set! a (call/cc (lambda (k) k)))
             (a (lambda (x) 1)) ) )
    2 )
   ))
   1
(splitter 
 (lambda (bottom)
   (define (call/cc f)
     (call/pc bottom (lambda (pc)
                       (f (lambda (v)
                            (abort bottom (lambda () (pc v))) )) )) )
   ((lambda (a b)
      (begin (set! a (call/cc (lambda (k) k)))
             (begin (set! b (+ 1 b))
                    (a (lambda (x) b)) ) ) )
    3 0 )
   ))
   2
;;; test that lexical contexts are preserved through continuations.
(splitter 
 (lambda (bottom)
   (define (call/cc f)
     (call/pc bottom (lambda (pc)
                       (f (lambda (v)
                            (abort bottom (lambda () (pc v))) )) )) )
   ((lambda (foo)
      (begin
        (set! foo ((lambda (z)
                     (lambda (x)
                       ((lambda (y) (begin (set! z x) y))
                        z ) ) )
                   'z ))
        (cons (foo (call/cc (lambda (k) ; store A and return Z
                              (k 'a) )))
              (cons (foo (call/cc (lambda (k) ; store B, return A
                                    (cons 1 (k 'b)) )))
                    (cons (foo (call/cc (lambda (k)
                                          ; store continuation, return B
                                          (cons 2 (k k)) )))
                          (cons ((lambda (x)
                                   (if (symbol? x) 'ee (x 'e)) )
                                 (foo 'd) )
                                (cons (foo 'f)
                                      '() ) ) ) ) ) ))
    'foo )
   ))
   (*or* (z a d ee d)   ; left->right
         (B ?- D EE Z)  ; right->left
         )
(splitter 
 (lambda (bottom)
   (define (call/cc f)
     (call/pc bottom (lambda (pc)
                       (f (lambda (v)
                            (abort bottom (lambda () (pc v))) )) )) )
   ((lambda (foo)
      (begin
        (set! foo ((lambda (z)
                     (lambda (x u)
                       ((lambda (y) (begin (set! z x) y))
                        z ) ) )
                   'z ))
        (cons (foo (call/cc (lambda (k)
                              (k 'a) ))
                   1 )
              (cons (foo (call/cc (lambda (k)
                                    (cons 1 (k 'b)) ))
                         2 )
                    (cons (foo (call/cc (lambda (k)
                                          (cons 2 (k k)) ))
                               3 )
                          (cons ((lambda (x)
                                   (if (symbol? x) 'ee (x 'e)) )
                                 (foo 'd 4) )
                                (cons (foo 'f 5) '()) ) ) ) ) ) )
    'foo )
   ))
   (*or* (z a d ee d)   ; left->right
         (B ?- D EE Z)  ; right->left
         )

;;;==================================================dynamic-wind
;;; These tests come from ~/themes/TVS/vts.tst
((lambda (a)
   (dynamic-wind (lambda () (set! a (cons 'pre a)))
                 (lambda () (set! a (cons 'in a)))
                 (lambda () (set! a (cons 'post a))) )
   a )
 '() )
   (post in pre)
((lambda (a)
   (dynamic-wind 
    (lambda () (set! a (cons 'pre a)))
    (lambda () (dynamic-wind (lambda () (set! a (cons 'ppre a)))
                             (lambda () (set! a (cons 'in a)))
                             (lambda () (set! a (cons 'ppost a))) ))
    (lambda () (set! a (cons 'post a))) )
   a )
 '() )
   (post ppost in ppre pre)
((lambda (a b)
   ((dynamic-wind (lambda () (set! a (cons 'pre a)))
                  (lambda () 
                    (new-call/cc (lambda (k) k)) )
                  (lambda () (set! a (cons 'post a))) )
    (lambda (x) x) )
    a )
 '() '() )
   (post pre post pre)
((lambda (a b)
   ((dynamic-wind (lambda () (set! a (cons 'pre a)))
                  (lambda () 
                    (dynamic-wind (lambda () (set! a (cons 'ppre a)))
                                  (lambda () (new-call/cc (lambda (k) k)))
                                  (lambda () (set! a (cons 'ppost a))) ) )
                  (lambda () (set! a (cons 'post a))) )
    (lambda (x) x) )
    a )
 '() '() )
   (post ppost ppre pre post ppost ppre pre)
;;; testing new-call/cc
(new-call/cc (lambda (k) 'a))
   a
(new-call/cc (lambda (k) (k 'a)))
   a
(new-call/cc (lambda (k) (cons (k 'a) 1)))
   a
(new-call/cc new-call/cc)
   ---
((lambda (a)
   (begin (set! a (new-call/cc (lambda (k) k)))
          (a (lambda (x) 1)) ) )
 2 )
   1
((lambda (a b)
   (begin (set! a (new-call/cc (lambda (k) k)))
          (begin (set! b (+ 1 b))
                 (a (lambda (x) b)) ) ) )
 3 0 )
   2
;;; test that lexical contexts are preserved through continuations.
((lambda (foo)
   (begin
     (set! foo ((lambda (z)
                  (lambda (x)
                    ((lambda (y) (begin (set! z x) y))
                     z ) ) )
                'z ))
     (cons (foo (new-call/cc (lambda (k) ; store A and return Z
                           (k 'a) )))
           (cons (foo (new-call/cc (lambda (k) ; store B, return A
                                 (cons 1 (k 'b)) )))
                 (cons (foo (new-call/cc (lambda (k)
                                           ; store continuation, return B
                                       (cons 2 (k k)) )))
                       (cons ((lambda (x)
                                (if (symbol? x) 'ee (x 'e)) )
                              (foo 'd) )
                             (cons (foo 'f)
                                   '() ) ) ) ) ) ))
 'foo )
   (*or* (z a d ee d)   ; left->right
         (B ?- D EE Z)  ; right->left
         )
((lambda (foo)
   (begin
     (set! foo ((lambda (z)
                  (lambda (x u)
                    ((lambda (y) (begin (set! z x) y))
                     z ) ) )
                'z ))
     (cons (foo (new-call/cc (lambda (k)
                           (k 'a) ))
                1 )
           (cons (foo (new-call/cc (lambda (k)
                                 (cons 1 (k 'b)) ))
                      2 )
                 (cons (foo (new-call/cc (lambda (k)
                                       (cons 2 (k k)) ))
                            3 )
                       (cons ((lambda (x)
                                (if (symbol? x) 'ee (x 'e)) )
                              (foo 'd 4) )
                             (cons (foo 'f 5) '()) ) ) ) ) ) )
 'foo )
   (*or* (z a d ee d)   ; left->right
         (B ?- D EE Z)  ; right->left
         )

;;; end of contlib.tst
